package be.ugent.psb.ModuleNetwork;

/**
 * Simple class to store regulator informations and sort them
 * 
 * @author erbon
 *
 */
public class RegData implements Comparable<Object> {
	/**
	 * Regulator weight
	 */
	Double weight;
	
	/**
	 * Regulator name
	 */
	String name;
	/**
	 * Constructor
	 * 
	 * @param w weight (double)
	 * @param g regulator (gene object)
	 * 
	 */
	public RegData(Double w, String n) {
		this.weight = w;
		this.name = n;
	}
	/**
	 * Comparator: compare RegData objects on weight values
	 */
	public int compareTo (Object o2) {
		int ret = 0;
		RegData r = (RegData) o2;
		if (weight < r.weight)
			ret = -1;
		else if (weight > r.weight)
			ret = 1;
		else if (weight.equals(r.weight))
			ret = 0;
		return ret;
	}
}
