/* LeMoNe - Learning Module Network
 * 
 * Copyright (C) 2005-2008 VIB 
 * 
 * Written by Tom Michoel, Eric Bonnet, Anagha Joshi, Steven Maere
 *  
*/

package be.ugent.psb.ModuleNetwork;

import java.io.*;
import java.util.*;

import be.ugent.psb.NetworkTools.Edge;
import be.ugent.psb.NetworkTools.Network;

/**
 * An example of the kind of analysis you can do with xml-files
 * generated by a LeMoNe run. 
 * 
 * @author tomic
 *
 */

public class RunXml {
    public static void main(String[] args) {
    	// input XML file or directory
    	String xmlFileIn = args[0];

    	// If you read in a single xml file, uncomment next line and comment the other
    	ModuleNetwork M = new ModuleNetwork(xmlFileIn);
    	//ModuleNetwork M = new ModuleNetwork(xmlFileIn, "", false);
    	
//    	M.printInModules("ath_cc_run4_moduleSets.txt");
    	
    	// find csgD and lrp
    	String csgD = "csgD_b1040_at";
    	String lrp = "lrp_b0889_at";
    	System.out.println(M.geneMap.get(csgD).number);
    	System.out.println(M.geneMap.get(lrp).number);
    	
//    	Module mod = M.moduleSets.get(1).get(65);
//    	for (TreeNode leaf : mod.hierarchicalTree.getLeafNodes())
//    		System.out.println(leaf.leafDistribution.gaussianParam[0] + "\t" + leaf.leafDistribution.gaussianParam[1]);
//    	for (TreeNode in : mod.hierarchicalTree.getInternalNodes()){
//    		Collections.sort(in.testSplits);
//    		in.regulationSplit = in.testSplits.get(0);
//    		System.out.println(in.regulationSplit.regulator.name + "\t" + in.regulationSplit.beta + "\t" + in.regulationSplit.splitValue);
//    	}
    	
    	// draw figures for all module sets, taking the best regulator for each tree node;
    	// a new directory is created for each module set
    	//Network refnet = new Network("/group/sysbiol/tomic/LeMoNe/results/Ecoli/", "allInteractions_regulonDBv5.7_namesFaithOnly.txt");

//    	mod.setRegulatorWeightsSum(1, 0.5);
//		Network net = new Network();
//		for (Gene reg : mod.regulatorWeights.keySet()){
//			Edge ed = new Edge(reg.name, String.format("module_%03d", mod.number+1), mod.regulatorWeights.get(reg));
//			int tp=0, fp=0;
//			for (Gene gene : mod.genes){
//				Edge e = new Edge(reg.name, gene.name);
//				e.validate(refnet);
//				if (e.valid==1)
//					tp += 1;
//				else if (e.valid == -1)
//					fp -= 1;
//			}
//			ed.valid = mod.genes.size();
//			ed.condSet.add(tp);
//			ed.condSet.add(fp);
//			net.edgeList.add(ed);
//		}
//		Collections.sort(net.edgeList);
//		for (Edge e : net.edgeList){
//			System.out.println(e.toString());
//		}
    	
     	
//    	for (TreeNode root : mod.hierarchicalTrees){
//    		for (TreeNode node : root.getInternalNodes()){
//				Collections.sort(node.testSplits);
//				node.regulationSplit = node.testSplits.get(0);
//			}
//    		Collections.sort(root.testSplits);
//    		System.out.println(root.testSplits.get(0).regulator.name);
//    		for (int k=0; k<root.testSplits.size(); k++){
//    			if (root.testSplits.get(k).regulator.name.equals("fis_b3261_at")){
//    				root.regulationSplit = root.testSplits.get(k);
//    				System.out.println(k);
//    				break;
//    			}
//    		}
//    		mod.hierarchicalTree = root;
//    		mod.draw("module_011.png");
//    	}
    	 
    	 
//		for (int k=0; k<M.moduleSets.size(); k++){
//			System.out.println(M.moduleSets.get(k).size());
//			String dir = String.format("figs/moduleSet_%02d/", k);
//			File figdir = new File(dir);
//			figdir.mkdirs();
//			for (Module mod : M.moduleSets.get(k)){
//				System.out.println(mod.genes.size());
//				mod.hierarchicalTree = mod.hierarchicalClustering(mod.initTreeList(), true);
//				mod.hierarchicalTree.testScore(0.05);
//				System.out.println("\t" + mod.hierarchicalTree.getLeafNodes().size());
//				for (TreeNode node : mod.hierarchicalTree.getInternalNodes())
//					node.findRegulatorBayes(M.regulatorSet, 20);
////				for (TreeNode node : mod.hierarchicalTree.getInternalNodes()){
////					Collections.sort(node.testSplits);
////					node.regulationSplit = node.testSplits.get(0);
////				}
////				if (mod.hierarchicalTree.nodeStatus.equals("internal"))
//					mod.draw(String.format(dir + "module_%03d.png", mod.number));
//			}
//		}
		
		
		// draw figures sorted by importance in the final network
//		String dir = "./";
//		ModuleNetworkAnalyzer A = new ModuleNetworkAnalyzer(M, true);
//		A.geneNetworkMax.setInModuleEdges(M);
//		Network net = A.geneNetworkMax;
//		//A.geneNetworkSum.setInModuleEdges(M);
//		//Network net = A.geneNetworkSum;
//		
//		net.setInModuleEdges(M);
//		
//		ArrayList<Edge> uniMods = new ArrayList<Edge>();
//		uniMods.add(net.edgeList.get(0));
//		for (int k=1; k<net.edgeList.size(); k++){
//			Edge e1 = net.edgeList.get(k);
//			Edge e2 = uniMods.get(uniMods.size()-1);
//			boolean same = true;
//			for (int i=0; i<e1.inModule.length; i++){
//				if (e1.inModule[i] != e2.inModule[i]){
//					same = false;
//					break;
//				}
//			}
//			if (!same){
//				uniMods.add(e1);
//			}
//		}
//		System.out.println("uni: " + uniMods.size());
//		
//		HashSet<String> names = new HashSet<String>();
//		for (int ms=0; ms<M.moduleSets.size(); ms++){
//			System.out.println(ms);
//			String dir2 = dir + String.format("figs2/moduleSet_%02d/", ms);
//			File f = new File(dir2);
//			f.mkdirs();
//			for (int i=0; i<1000; i++){
//				Edge e = net.edgeList.get(i);
//				String name = String.format("%s_module_%03d.png", e.source, e.inModule[ms]);
//				if (!names.contains(name)){
//					names.add(name);
//					Module mod = M.moduleSets.get(ms).get(e.inModule[ms]);
//					for (TreeNode node : mod.hierarchicalTree.getInternalNodes()){
//						node.leafDistribution.condSet = new ArrayList<Integer>();
//						for (TreeNode leaf : node.getLeafNodes())
//							for (int m : leaf.leafDistribution.condSet)
//								node.leafDistribution.condSet.add(m);
//						Collections.sort(node.testSplits);
//						HashMap<String,Split> map = new HashMap<String,Split>();
//						for (Split splt : node.testSplits){
//							map.put(splt.regulator.name, splt);
//						}
//						if (map.keySet().contains(e.source))
//							node.regulationSplit = map.get(e.source);
//						else
//							node.regulationSplit = node.testSplits.get(0);
//					}
//					if (mod.hierarchicalTree.nodeStatus.equals("internal")){
//						mod.draw(String.format(dir2 + "%03d_%s_module_%03d.png", i, e.source, e.inModule[ms]));
//					}
//				}
//			}
//		}
		
		// to relearn regulation programs with different parameter settings:
		// first, redo Gibbs sampling, this is only necessary if the xml file(s) have one consensus tree per modulee
//		int numRuns=1, numSteps=1100, burnIn=100, sampleStep=100;
//		double scoregain=0.0;
//		boolean useBHCscore=true;
//		M.gibbsSamplerExpts(numRuns, numSteps, burnIn, sampleStep, scoregain, useBHCscore);
//		// second, remake consensus tree
//		int cutLevel=1, minSizeExpt=25;
//		double signiFact=1.0;
//		M.makeConsensusTrees(cutLevel, minSizeExpt, signiFact);
//		// third, assign regulators
//		double betaMax=20.0;
//		int numRegAssign=100;
//		M.assignRegulatorsNoAcyclStoch(betaMax, numRegAssign);
//		// save to new file
//		M.save();
//		
//		// create an analyzer with a reference network of known interactions stored in a text file
//		String refNetDir = "/group/biocomp/sysbiol/tomic/LeMoNe/results/Ecoli";
//		String refNetFile = "allInteractions_regulonDBv5.7_namesFaithOnly.txt";
//		ModuleNetworkAnalyzer A = new ModuleNetworkAnalyzer(M, true, refNetDir, refNetFile);
//		
//		// compute recall - precision for the full ranked list of edges, print output to a text file
//		A.printRecallPrecision("rp.txt", A.geneNetworkMax.numEdges);
//		
//		// validate the edges against the reference network
//		A.geneNetworkMax.validateEdges(A.referenceNetwork);
//		
//		// for each edge, compute the modules to which the target node belongs and whether the
//		// source node activates, represses or does not regulate that module
//		A.geneNetworkMax.setInModuleEdges(M);
//
//		// print the 1000 highest ranked edges to a text file, if the previous two
//		// computations have been performed, this information is automatically printed as well
//		A.geneNetworkMax.printEdges("edges.txt", 1000);

    }
    

}
