/* LeMoNe - Learning Module Network
 * 
 * Copyright (C) 2005-2008 VIB 
 * 
 * Written by Tom Michoel, Eric Bonnet, Anagha Joshi, Steven Maere
 *  
*/

package be.ugent.psb.NumericalRecipes;

/**
 * Desribes the methods a class must have to run a simulated annealing procedure.
 * 
 * @author tomic
 * 
 */
public interface SimAnnealConfiguration {
	
	/**
	 * Replaces the current configuration by a random configuration.
	 * 
	 * @return new configuration.
	 */
	SimAnnealConfiguration randomInit();
	
	/**
	 * Makes a random change to the current configuration.
	 * 
	 * @return new configuration.
	 */
	SimAnnealConfiguration randomChange();
	
	/**
	 * Computes the function to be minimized.
	 * 
	 * @return value.
	 */
	double energyFunction();
	
}
